#define _USE_MATH_DEFINES

#include <algorithm>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <vector>
#include <cmath>

using namespace std;

typedef pair<int, int> PII;

const int tests_start = 10;

ofstream out;
int current_test;

int my_rand(int L, int R)
{
    int r = rand() * rand() + rand();
    return L + r % (R-L+1);
}

void new_test()
{
    if (current_test >= tests_start) out.close();
    current_test++;
    ostringstream ss;
    ss << setfill('0') << setw(2) << current_test;
    out.open(ss.str().c_str());
    cout << ss.str() << endl;
}

void gen_random(int n, int days, int pmax, int dd = 1)
{
    new_test();
    out << n << endl;
    for (int i = 0; i < n; i++) {
        int L = my_rand(1, days-dd);
        int R = my_rand(L+dd, days);
        int p = my_rand(1, pmax);
        out << L << " " << R << " " << p << endl;
    }
}

void gen_max()
{
    new_test();
    int n = 100000;
    out << n << endl;
    for (int i = 0; i < n; i++) {
        out << "99999 100000 100000" << endl;
    }   
}

int main()
{
    current_test = tests_start-1;
    srand(63341);

    //     
    gen_random(5, 10, 100);
    gen_random(5, 100, 1000);
    gen_random(10, 10, 10);
    gen_random(10, 100, 1000);
    gen_random(100, 10, 1000);
    gen_random(100, 1000, 1000);

    //,      
    gen_random(1000, 100000, 100000, 1000);
    gen_random(100000, 1000, 1000, 10);

    //,     
    gen_random(100000, 10000, 100000, 100);
    gen_random(10000, 100000, 100000, 100);
    gen_random(100000, 100000, 100000, 100);

    // ,  
    gen_max();
}
