#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <queue>

using namespace std;

const int maxn = 100010;

int n, max_day;
int L[maxn], R[maxn], p[maxn];
int seq_L[maxn];

bool book_less(const int& i, const int& j)
{
    return L[i] < L[j];
}

bool can(long long ppd)
{
    priority_queue<pair<int, int> > active;
    int lp = 0, rp = 0;
    for (int day = 1; day <= max_day; day++) {
        //     ,   ,   
        while (!active.empty()) {
            pair<int, int> top = active.top();
            assert(-top.first >= day);
            if (-top.first == day) {
                return false; //         
            } else {
                break;
            }
        }
        
        //  
        while (lp < n && L[seq_L[lp]] == day) {
            int book = seq_L[lp];
            active.push(make_pair(-R[book], p[book]));
            lp++;
        }

        // .   ,   
        long long pages = 0;
        while (pages < ppd && !active.empty()) {
            pair<int, int> top = active.top();
            if (ppd-pages >= top.second) {
                pages += top.second;
                active.pop(); //     
            } else {
                active.pop();
                top.second -= ppd-pages;
                pages = ppd;
                active.push(top);
            }
        }
    }
    return true;
}

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);

    int i;
    
    long long sum = 0;
    max_day = 0;
    scanf("%d", &n);
    for (i = 0; i < n; i++) {
        scanf("%d%d%d", &L[i], &R[i], &p[i]);
        seq_L[i] = i;
        sum += p[i];
        max_day = max(max_day, R[i]);
    }
    sort(seq_L+0, seq_L+n, book_less);

    long long low = 1;
    long long hi = sum;
    while (hi-low > 1) {
        long long q = (hi + low) / 2;
        if (can(q)) hi = q; else low = q+1;
    }
    long long ans = low;
    if (!can(ans)) ans++;

    cout << ans << endl;

    fclose(stdin); fclose(stdout);
    return 0;
}
